/**
 * @copyright 2015, Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createDecoratedClass = (function () { function defineProperties(target, descriptors, initializers) { for (var i = 0; i < descriptors.length; i++) { var descriptor = descriptors[i]; var decorators = descriptor.decorators; var key = descriptor.key; delete descriptor.key; delete descriptor.decorators; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor || descriptor.initializer) descriptor.writable = true; if (decorators) { for (var f = 0; f < decorators.length; f++) { var decorator = decorators[f]; if (typeof decorator === 'function') { descriptor = decorator(target, key, descriptor) || descriptor; } else { throw new TypeError('The decorator for method ' + descriptor.key + ' is of the invalid type ' + typeof decorator); } } if (descriptor.initializer !== undefined) { initializers[key] = descriptor; continue; } } Object.defineProperty(target, key, descriptor); } } return function (Constructor, protoProps, staticProps, protoInitializers, staticInitializers) { if (protoProps) defineProperties(Constructor.prototype, protoProps, protoInitializers); if (staticProps) defineProperties(Constructor, staticProps, staticInitializers); return Constructor; }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _autobindDecorator = require('autobind-decorator');

var _autobindDecorator2 = _interopRequireDefault(_autobindDecorator);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodashFunctionDebounce = require('lodash/function/debounce');

var _lodashFunctionDebounce2 = _interopRequireDefault(_lodashFunctionDebounce);

var _reactStylesheet = require('react-stylesheet');

var Stylesheet = _interopRequireWildcard(_reactStylesheet);

var _reactDomStylesheet = require('react-dom-stylesheet');

var _emptyFunction = require('empty/function');

var _emptyFunction2 = _interopRequireDefault(_emptyFunction);

var _tether = require('tether');

var _tether2 = _interopRequireDefault(_tether);

var _Layer = require('./Layer');

var _Layer2 = _interopRequireDefault(_Layer);

var _ResultList = require('./ResultList');

var _ResultList2 = _interopRequireDefault(_ResultList);

var KEYS = {
  ARROW_UP: 'ArrowUp',
  ARROW_DOWN: 'ArrowDown',
  ENTER: 'Enter',
  ESCAPE: 'Escape'
};

var TETHER_CONFIG = {
  attachment: 'top left',
  targetAttachment: 'bottom left',
  optimizations: {
    moveElement: false
  },
  constraints: [{
    to: 'window',
    attachment: 'together'
  }]
};

var Autocomplete = (function (_React$Component) {
  _inherits(Autocomplete, _React$Component);

  _createClass(Autocomplete, null, [{
    key: 'propTypes',
    value: {

      /**
       * Option object is opaque to <Autocomplete /> component.
       *
       * It is passed to `search` function (also passed as props) along with
       * the current `searchTerm` to return a list of results.
       *
       * The default `search` function expectds `options` to be an array of
       * objects with `title` attribute on which search is performed.
       */
      options: _react.PropTypes.any,

      /**
       * Search function.
       *
       * It accepts three arguments: `options`, `searchTerm` and `cb`:
       *
       * * `options` is the `options` prop passed to <Autocomplete />.
       * * `searchTerm` is the current value of input
       * * `cb` is a Node-style callback which should be used to return results
       *   back to <Autocomplete />
       */
      search: _react.PropTypes.func,

      /**
       * Value.
       *
       * Should be an object with `title` attribute.
       */
      value: _react.PropTypes.object,

      /**
       * Callback which is called when a result is being choosen.
       */
      onChange: _react.PropTypes.func,

      /**
       * Callback which is called when the `search` function returns an error.
       */
      onError: _react.PropTypes.func,

      /**
       * Input placeholder.
       */
      placeholder: _react.PropTypes.string
    },
    enumerable: true
  }, {
    key: 'defaultProps',
    value: {
      search: searchArray,
      onChange: _emptyFunction2['default'],
      onClick: _emptyFunction2['default'],
      onFocus: _emptyFunction2['default'],
      onBlur: _emptyFunction2['default']
    },
    enumerable: true
  }, {
    key: 'stylesheet',
    value: Stylesheet.create({
      Root: {
        position: 'relative',
        outline: 'none'
      },
      Input: {
        Component: 'input',
        width: '100%'
      },
      ResultList: _ResultList2['default']
    }, { styleHostComponent: _reactDomStylesheet.style }),
    enumerable: true
  }]);

  function Autocomplete(props) {
    _classCallCheck(this, Autocomplete);

    _get(Object.getPrototypeOf(Autocomplete.prototype), 'constructor', this).call(this, props);

    this._list = null;
    this._search = null;

    this._ignoreFocus = false;
    this._tether = null;
    this._setOpenDebounced = (0, _lodashFunctionDebounce2['default'])(this._setOpen, 0);
    this.state = {
      open: false,
      results: [],
      searchTerm: this._searchTermFromProps(this.props),
      value: this.props.value,
      focusedValue: null
    };
  }

  _createDecoratedClass(Autocomplete, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var placeholder = _props.placeholder;

      var props = _objectWithoutProperties(_props, ['placeholder']);

      var _constructor$stylesheet = this.constructor.stylesheet;
      var Root = _constructor$stylesheet.Root;
      var Input = _constructor$stylesheet.Input;
      var ResultList = _constructor$stylesheet.ResultList;
      var open = this.state.open;

      return _react2['default'].createElement(
        Root,
        _extends({}, props, {
          value: undefined,
          search: undefined,
          onChange: undefined,
          onError: undefined,
          options: undefined }),
        _react2['default'].createElement(Input, {
          ref: this._onSearchRef,
          style: { width: '100%' },
          onKeyDown: this._onQueryKeyDown,
          onClick: this._onClick,
          onFocus: this._onFocus,
          onBlur: this._onBlur,
          placeholder: placeholder,
          onChange: this._onQueryChange,
          value: this.state.searchTerm
        }),
        open && this.state.results.length > 0 && _react2['default'].createElement(
          _Layer2['default'],
          {
            didMount: this._layerDidMount,
            didUpdate: this._layerDidUpdate,
            willUnmount: this._layerWillUnmount },
          _react2['default'].createElement(ResultList, {
            ref: this._onListRef,
            onKeyDown: this._onQueryKeyDown,
            onFocus: this._onListFocus,
            onBlur: this._onListBlur,
            onSelect: this._onValueChange,
            results: this.state.results,
            focusedValue: this.state.focusedValue
          })
        )
      );
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (!equalValue(nextProps.value, this.props.value)) {
        var searchTerm = this._searchTermFromProps(nextProps);
        this.setState({
          searchTerm: searchTerm,
          value: nextProps.value
        });
      }
    }
  }, {
    key: 'showResults',
    decorators: [_autobindDecorator2['default']],
    value: function showResults(searchTerm) {
      this.setState({ results: [] });
      this.props.search(this.props.options, searchTerm.trim(), this._onSearchComplete);
    }
  }, {
    key: 'showAllResults',
    decorators: [_autobindDecorator2['default']],
    value: function showAllResults() {
      this.showResults('');
      this._open();
    }
  }, {
    key: '_onListRef',
    decorators: [_autobindDecorator2['default']],
    value: function _onListRef(ref) {
      this._list = ref;
    }
  }, {
    key: '_onSearchRef',
    decorators: [_autobindDecorator2['default']],
    value: function _onSearchRef(ref) {
      this._search = ref;
    }
  }, {
    key: '_onFocus',
    decorators: [_autobindDecorator2['default']],
    value: function _onFocus(e) {
      if (!this._ignoreFocus && !this.state.open) {
        this.showAllResults();
      }
      this.props.onFocus(e); // eslint-disable-line react/prop-types
    }
  }, {
    key: '_onBlur',
    decorators: [_autobindDecorator2['default']],
    value: function _onBlur(e) {
      if (!this._ignoreFocus) {
        this._close();
      }
      this.props.onBlur(e); // eslint-disable-line react/prop-types
    }
  }, {
    key: '_onListFocus',
    decorators: [_autobindDecorator2['default']],
    value: function _onListFocus() {
      if (!this._ignoreFocus) {
        this._open();
      }
    }
  }, {
    key: '_onListBlur',
    decorators: [_autobindDecorator2['default']],
    value: function _onListBlur() {
      if (!this._ignoreFocus) {
        this._close();
      }
    }
  }, {
    key: '_layerDidMount',
    decorators: [_autobindDecorator2['default']],
    value: function _layerDidMount(element) {
      var target = _react2['default'].findDOMNode(this._search);
      var size = target.getBoundingClientRect();
      element.style.width = size.width + 'px';
      this._tether = new _tether2['default'](_extends({ element: element, target: target }, TETHER_CONFIG));
    }
  }, {
    key: '_layerDidUpdate',
    decorators: [_autobindDecorator2['default']],
    value: function _layerDidUpdate() {
      this._tether.position();
    }
  }, {
    key: '_layerWillUnmount',
    decorators: [_autobindDecorator2['default']],
    value: function _layerWillUnmount() {
      this._tether.disable();
      this._tether = null;
    }
  }, {
    key: '_setOpen',
    decorators: [_autobindDecorator2['default']],
    value: function _setOpen(open) {
      this.setState(function (state) {
        state = _extends({}, state, { open: open });
        if (!open) {
          if (state.value) {
            state = _extends({}, state, { searchTerm: state.value.title });
          } else {
            state = _extends({}, state, { searchTerm: '' });
          }
        }
        return state;
      });
    }
  }, {
    key: '_open',
    decorators: [_autobindDecorator2['default']],
    value: function _open() {
      this._setOpenDebounced(true);
    }
  }, {
    key: '_close',
    decorators: [_autobindDecorator2['default']],
    value: function _close() {
      this._setOpenDebounced(false);
    }
  }, {
    key: '_focus',
    decorators: [_autobindDecorator2['default']],
    value: function _focus() {
      this._ignoreFocus = true;
      _react2['default'].findDOMNode(this._search).focus();
      this.setState({ focusedValue: null });
      this._ignoreFocus = false;
    }
  }, {
    key: '_focusAndClose',
    decorators: [_autobindDecorator2['default']],
    value: function _focusAndClose() {
      this._focus();
      this._close();
    }
  }, {
    key: '_searchTermFromProps',
    decorators: [_autobindDecorator2['default']],
    value: function _searchTermFromProps(props) {
      var searchTerm = props.searchTerm;
      var value = props.value;

      if (!searchTerm && value) {
        searchTerm = value.title;
      }
      return searchTerm || '';
    }
  }, {
    key: '_onValueChange',
    decorators: [_autobindDecorator2['default']],
    value: function _onValueChange(value) {
      this.setState({
        value: value,
        focusedValue: value,
        searchTerm: value ? value.title : this.state.searchTerm
      }, this._focusAndClose);
      this.props.onChange(value);
    }
  }, {
    key: '_onSearchComplete',
    decorators: [_autobindDecorator2['default']],
    value: function _onSearchComplete(err, results) {
      if (err) {
        if (this.props.onError) {
          this.props.onError(err);
        } else {
          throw err;
        }
      }

      this.setState({
        open: true,
        results: results
      });
    }
  }, {
    key: '_onQueryChange',
    decorators: [_autobindDecorator2['default']],
    value: function _onQueryChange(e) {
      var searchTerm = e.target.value;
      var nextState = {
        searchTerm: searchTerm,
        focusedValue: null
      };
      if (searchTerm === '') {
        nextState.value = null;
        this.props.onChange(null);
      }
      this.setState(nextState);
      this.showResults(searchTerm);
    }
  }, {
    key: '_onClick',
    decorators: [_autobindDecorator2['default']],
    value: function _onClick(e) {
      if (!this.state.open) {
        this.showAllResults();
      }
      this.props.onClick(e); // eslint-disable-line react/prop-types
    }
  }, {
    key: '_onQueryKeyDown',
    decorators: [_autobindDecorator2['default']],
    value: function _onQueryKeyDown(e) {
      var _state = this.state;
      var open = _state.open;
      var focusedValue = _state.focusedValue;
      var results = _state.results;

      switch (e.key) {
        case KEYS.ENTER:
          e.preventDefault();
          this._onValueChange(focusedValue);
          break;
        case KEYS.ESCAPE:
          this._focusAndClose();
          break;
        case KEYS.ARROW_UP:
          if (!open) {
            break;
          }
          e.preventDefault();
          var prevIdx = Math.max(this._indexOfFocusedValue - 1, -1);
          if (prevIdx === -1) {
            this._focus();
          } else {
            this.setState({
              searchTerm: results[prevIdx].title,
              focusedValue: results[prevIdx]
            });
          }
          break;
        case KEYS.ARROW_DOWN:
          e.preventDefault();
          if (open) {
            var nextIdx = Math.min(this._indexOfFocusedValue + (open ? 1 : 0), results.length);
            if (nextIdx === results.length) {
              this._focus();
            } else {
              this.setState({
                searchTerm: results[nextIdx].title,
                focusedValue: results[nextIdx]
              });
            }
          } else {
            this.showAllResults();
          }
          break;
        default:
          break;
      }
    }
  }, {
    key: '_indexOfFocusedValue',
    get: function get() {
      if (!this.state.focusedValue) {
        return -1;
      }
      for (var i = 0, len = this.state.results.length; i < len; i++) {
        if (this.state.results[i].id === this.state.focusedValue.id) {
          return i;
        }
      }
      return -1;
    }
  }]);

  return Autocomplete;
})(_react2['default'].Component);

exports['default'] = Autocomplete;

function equalValue(a, b) {
  return !a && !b || a && b && a.id == b.id && a.title === b.title // eslint-disable-line eqeqeq
  ;
}

/**
* Search options using specified search term treating options as an array
* of candidates.
*
* @param {Array.<Object>} options
* @param {String} searchTerm
* @param {Callback} cb
*/
function searchArray(options, searchTerm, cb) {
  if (!options) {
    return cb(null, []);
  }

  searchTerm = new RegExp(searchTerm, 'i');

  var results = [];

  for (var i = 0, len = options.length; i < len; i++) {
    if (searchTerm.exec(options[i].title)) {
      results.push(options[i]);
    }
  }

  cb(null, results);
}
module.exports = exports['default'];
