/**
 * @copyright 2015, Prometheus Research, LLC
 */

'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _domScrollIntoView = require('dom-scroll-into-view');

var _domScrollIntoView2 = _interopRequireDefault(_domScrollIntoView);

var _reactStylesheet = require('react-stylesheet');

var Stylesheet = _interopRequireWildcard(_reactStylesheet);

var _reactDomStylesheet = require('react-dom-stylesheet');

var _Result = require('./Result');

var _Result2 = _interopRequireDefault(_Result);

var ResultList = (function (_React$Component) {
  _inherits(ResultList, _React$Component);

  function ResultList() {
    _classCallCheck(this, ResultList);

    _get(Object.getPrototypeOf(ResultList.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(ResultList, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var results = _props.results;

      var props = _objectWithoutProperties(_props, ['results']);

      var Root = this.constructor.stylesheet.Root;

      return _react2['default'].createElement(
        Root,
        _extends({}, props, { tabIndex: -1 }),
        results.map(this.renderResult, this)
      );
    }
  }, {
    key: 'renderResult',
    value: function renderResult(result) {
      var focus = this.props.focusedValue && this.props.focusedValue.id === result.id;
      return _react2['default'].createElement(this.constructor.stylesheet.Result, {
        ref: focus ? 'focus' : undefined,
        key: result.id,
        result: result,
        focus: focus,
        onClick: this.props.onSelect
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._scrollToFocused();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.focusedValue !== this.props.focusedValue) {
        this._scrollToFocused();
      }
    }
  }, {
    key: '_scrollToFocused',
    value: function _scrollToFocused() {
      var focus = this.refs && this.refs.focus;
      if (focus) {
        var container = _react2['default'].findDOMNode(this);
        var node = _react2['default'].findDOMNode(focus);
        (0, _domScrollIntoView2['default'])(node, container, { onlyScrollIfNeeded: true });
        node.focus();
      }
    }
  }], [{
    key: 'propTypes',
    value: {
      results: _react.PropTypes.array,
      focusedValue: _react.PropTypes.object,
      onSelect: _react.PropTypes.func
    },
    enumerable: true
  }, {
    key: 'stylesheet',
    value: Stylesheet.create({
      Root: 'ul',
      Result: _Result2['default']
    }, { styleHostComponent: _reactDomStylesheet.style }),
    enumerable: true
  }]);

  return ResultList;
})(_react2['default'].Component);

exports['default'] = ResultList;
module.exports = exports['default'];
